% Implemented by Davide Martinenghi 1999 for the Demo system
%
% See legal notice in the end of this file.
%
% Make sure the event calculus main program 'eventcalculus/ec.pl' is loaded
% and load the file as follows:
/*
	['eventcalculus/diskABC'].
*/

/*
Description of the domain:
We have three pegs (A, B, C) and a disk which is put on peg A at time t0.
From peg A we can move it to peg B.
From peg B we can move it to peg C.
The goal is to have the disk on peg C at time tF>t0.

The actions in our domain are moveAB and moveBC
The fluents are onA, onB and onC.
*/

object_module( domain,

     \[ (initiates(movesAB,onB,'T') :- holdsAt(yes,onA,'T')),
        (initiates(movesBC,onC,'T') :- holdsAt(yes,onB,'T')),

        (terminates(movesAB,onA,'T') :- holdsAt(yes,onA,'T')),
        (terminates(movesBC,onB,'T') :- holdsAt(yes,onB,'T')),
        
	initiallyTrue(onA),
	initiallyFalse(onB),
	initiallyFalse(onC)
	
	]).

%%% Definition of the sorts of the language:
fluent(\\\ onA).
fluent(\\\ onB).
fluent(\\\ onC).
action(\\\ movesAB).
action(\\\ movesBC).
timepoint(T) :- constant_(T).

%%% GOALS:
/*
 ec(\domain,\\holdsAt(yes,onC,tF),A).

A = \ (	[(happens(movesBC,newConst0):-true),
	(happens(movesAB,newConst1):-true)] &

	[(clipped(no,t0,onA,newConst1):-true),
	(clipped(no,newConst1,onB,newConst0):-true),
	(clipped(no,newConst0,onC,tF):-true)] &
	
	[(newConst1<newConst0:-true),
	(newConst0<tF:-true)]) ? ;

	no
*/

%%%%%%%
%%%%%%% Copyright (C) Henning Christiansen 1998, Roskilde University, Denmark
%%%%%%% E-mail henning@ruc.dk
%%%%%%% 
%%%%%%% The code contained in this file must not be applied
%%%%%%% in any commercial product without written permission
%%%%%%% from the copyright holder.
%%%%%%%
%%%%%%% Permission is granted to use, copy, modify, and distribute
%%%%%%% this file for scientific and educational purposes provided
%%%%%%% that the copyright notice and these remarks are maintained.
%%%%%%% The copyright holder or author takes no responsibility for
%%%%%%% any loss or damage caused by this code.
%%%%%%%
%%%%%%% Web site for the DemoII system: http://www.dat.ruc.dk/software/demo.html
