% Implemented by Davide Martinenghi 1999 for the Demo system
%
% See legal notice in the end of this file.
%
% Make sure the event calculus main program 'eventcalculus/ec.pl' is loaded
% and load the file as follows:
/*
	['eventcalculus/shakey'].
*/

%%% SCHEMATIZATION OF THE "SHAKEY" DOMAIN
object_module( domain,
     \[
	%%% ROOM CONNECTIVITY
	connects(d1,r1,r2),
	connects(d2,r2,r3),
	connects(d3,r2,r4),
	connects(d4,r3,r4),
	connects(d5,r4,r5),
	connects(d6,r4,r6),
%	(connects('D','R1','R2'):-connects('D','R2','R1')),
	
	%%% DOMAIN
        (initiates(gothrough('D'),inroom('R1'),'T') :-
        	connects('D','R2','R1'), holdsAt(yes,inroom('R2'),'T')),

        (terminates(gothrough('D'),inroom('R'),'T') :- holdsAt(yes,inroom('R'),'T')),
        
	%%% NARRATIVE
	initiallyTrue(inroom(r3))
	]).

%%% Definition of the sorts of the language:
fluent(\\\ inroom(?R)) :- constant_(R).
action(\\\ gothrough(?D)) :- constant_(D).
timepoint(T) :- constant_(T).

%%% GOALS:
/*
 ec(\domain,\\holdsAt(yes,inroom(r6),t),A).

A = \ (	[(happens(gothrough(d6),newConst0):-true),
	(happens(gothrough(d4),newConst1):-true)] &

	[(clipped(no,t0,inroom(r3),newConst1):-true),
	(clipped(no,newConst1,inroom(r4),newConst0):-true),
	(clipped(no,newConst0,inroom(r6),t):-true)] &

	[(newConst1<newConst0:-true),
	(newConst0<t:-true)]) ? ;

	no
*/

%%%%%%%
%%%%%%% Copyright (C) Henning Christiansen 1998, Roskilde University, Denmark
%%%%%%% E-mail henning@ruc.dk
%%%%%%% 
%%%%%%% The code contained in this file must not be applied
%%%%%%% in any commercial product without written permission
%%%%%%% from the copyright holder.
%%%%%%%
%%%%%%% Permission is granted to use, copy, modify, and distribute
%%%%%%% this file for scientific and educational purposes provided
%%%%%%% that the copyright notice and these remarks are maintained.
%%%%%%% The copyright holder or author takes no responsibility for
%%%%%%% any loss or damage caused by this code.
%%%%%%%
%%%%%%% Web site for the DemoII system: http://www.dat.ruc.dk/software/demo.html
