%%%%%%% This file is part of the DemoII system produced
%%%%%%% 1997-1999 by Davide Martinenghi and Henning Christiansen
%%%%%%%
%%%%%%% Contact:    henning@ruc.dk
%%%%%%%
%%%%%%% See legal notice in the end of this file.
%%%%%%%
%%%%%%% The code has been developed and tested for SICStus Prolog 3.7
%%%%%%%
%%%%%%% Filename: demo_predicate.pl

demo(P, Q) :-
	program_(P),
	no_duplicates_(P),
	instance_(Q, Q1),
	demo1(P, Q1).

demo1(_, \\true).

demo1(P, \\ (?Pred ^ ?ArgListA)) :-
	% pre-unification for efficiency...
	member_( \ (?Pred ^ ?ArgListH :- ?B), P),
	instance_( \ (?Pred ^ ?ArgListH :- ?B), \ (?Pred ^ ?ArgListA :- ?B1)),
	demo1(P, B1).

demo1(_, \\ (?T1 = ?T2)) :- T1 = T2.

demo1(_, \\ dif(?T1, ?T2)) :- dif(T1, T2).

demo1(P, \\ (? A, ?B)) :- demo1(P, A), demo1(P, B).

demo1(P, \\ (? A; ?B)) :- demo1(P, A); demo1(P, B).

%%%%%%%
%%%%%%% Copyright (C) Henning Christiansen 1998, Roskilde University, Denmark
%%%%%%% E-mail henning@ruc.dk
%%%%%%% 
%%%%%%% The code contained in this file must not be applied
%%%%%%% in any commercial product without written permission
%%%%%%% from the copyright holder.
%%%%%%%
%%%%%%% Permission is granted to use, copy, modify, and distribute
%%%%%%% this file for scientific and educational purposes provided
%%%%%%% that the copyright notice and these remarks are maintained.
%%%%%%% The copyright holder or author takes no responsibility for
%%%%%%% any loss or damage caused by this code.
%%%%%%%
%%%%%%% Web site for the DemoII system: http://www.dat.ruc.dk/software/index.html
