%%%%%%% This file is part of the DemoII system produced
%%%%%%% 1997-1999 by Davide Martinenghi and Henning Christiansen
%%%%%%%
%%%%%%% Contact:    henning@ruc.dk
%%%%%%%
%%%%%%% See legal notice in the end of this file.
%%%%%%%
%%%%%%% The code has been developed and tested for SICStus Prolog 3.7
%%%%%%%
%%%%%%% Filename: loader.pl

:- module(m, [demo_consult/1, demo_use_module/1, demo_use_module/2]).

:- meta_predicate demo_consult(:), demo_use_module(:), demo_use_module(:,+).

demo_consult(X) :-
	user:demo_compiled -> load_files(X, [load_type(source),compilation_mode(compile),if(changed)]) ;
	consult(X).

demo_use_module(X) :-
	user:demo_compiled -> load_files(X, [load_type(source),compilation_mode(compile),if(changed)]) ;
	use_module(X).

demo_use_module(X,Y) :-
	user:demo_compiled -> load_files(X, [load_type(source),compilation_mode(compile),imports(Y),if(changed)]) ;
	use_module(X,Y).

%%%%%%%
%%%%%%% Copyright (C) Henning Christiansen 1998, Roskilde University, Denmark
%%%%%%% E-mail henning@ruc.dk
%%%%%%% 
%%%%%%% The code contained in this file must not be applied
%%%%%%% in any commercial product without written permission
%%%%%%% from the copyright holder.
%%%%%%%
%%%%%%% Permission is granted to use, copy, modify, and distribute
%%%%%%% this file for scientific and educational purposes provided
%%%%%%% that the copyright notice and these remarks are maintained.
%%%%%%% The copyright holder or author takes no responsibility for
%%%%%%% any loss or damage caused by this code.
%%%%%%%
%%%%%%% Web site for the DemoII system: http://www.dat.ruc.dk/software/index.html
