%%%%%%% This file is part of the DemoII system produced
%%%%%%% 1997-1999 by Davide Martinenghi and Henning Christiansen
%%%%%%%
%%%%%%% Contact:    henning@ruc.dk
%%%%%%%
%%%%%%% See legal notice in the end of this file.
%%%%%%%
%%%%%%% The code has been developed and tested for SICStus Prolog 3.7
%%%%%%%
%%%%%%% Filename: tc.pl

constraints type/2.

% the following if we want to use chr tracer
%option(debug_compile, on).


tRule1 @ type(T1,Var), type(T2,Var) # Id <=>
	lct(T1,T2,T),
	type(T,Var)
	pragma passive(Id).

tRule2 @ type(T1, gr(T2,Sym,List)) <=>
	(T1=T2; subtype(T1,T2)),
	operator_exists(Sym, InTypes, T2, List),
	type(InTypes, List).

tRule3 @ type([], []) <=> true.

tRule4 @ type([HT|TT], [H|T]) <=> type(HT,H), type(TT,T).

tRule5 @ type(SType, []) <=> SType= *(_).

tRule6a @ type(+(Type), [H|T]) <=> type(Type,H), type(*(Type),T).

tRule6b @ type(*(Type), [H|T]) <=> type(Type,H), type(*(Type),T).

tRule7 @ type(_, X) <=> nonvar(X) | fail.

/*
% TEST QUERIES:
clause_(\ (?A :- p(?X), ?B)).
	formula_(B),
	term_(X),
	atom_(A)
clause_(\ (?A :- p(?X), ?X)).
	no
term_(\\\a).
	yes
*/

%%%%%%%
%%%%%%% Copyright (C) Henning Christiansen 1998, Roskilde University, Denmark
%%%%%%% E-mail henning@ruc.dk
%%%%%%% 
%%%%%%% The code contained in this file must not be applied
%%%%%%% in any commercial product without written permission
%%%%%%% from the copyright holder.
%%%%%%%
%%%%%%% Permission is granted to use, copy, modify, and distribute
%%%%%%% this file for scientific and educational purposes provided
%%%%%%% that the copyright notice and these remarks are maintained.
%%%%%%% The copyright holder or author takes no responsibility for
%%%%%%% any loss or damage caused by this code.
%%%%%%%
%%%%%%% Web site for the DemoII system: http://www.dat.ruc.dk/software/index.html
