%%%%%%% This file is part of the DemoII system produced
%%%%%%% 1997-1999 by Davide Martinenghi and Henning Christiansen
%%%%%%%
%%%%%%% Contact:    henning@ruc.dk
%%%%%%%
%%%%%%% See legal notice in the end of this file.
%%%%%%%
%%%%%%% The code has been developed and tested for SICStus Prolog 3.7
%%%%%%%
%%%%%%% Filename: type_definitions.pl

%%% TYPES AND SUBTYPES
type term quoted by (\\\).
subtype constant < term.
subtype variable < term.
subtype structure < term.

type formula quoted by (\\).
subtype atom < formula.
subtype constraint < formula.

type clause quoted by (\).

type program quoted by (\).

%% operators for \\
operator any-head : *(term) --> atom.
operator ',' : formula * formula --> formula.
operator ';' : formula * formula --> formula.
operator true : --> formula.
operator = : term * term --> constraint.
operator dif : term * term --> constraint.

%% operators for \\\
operator any-prolog_atomic : --> constant.
operator any-variable_id : --> variable.
operator any-anonymous_variable_id : --> variable,
	{ generate_variable_id(V) }
	stands for gr(variable, V, []).
operator any-compound :	+(term) --> structure.

%% operators for \
operator :- : atom * formula --> clause.
operator any-head^P^AL : *(term) --> clause,
	{ es:translate(\ (?P ^ ?AL:-true),O) }
	stands for O.
operator [] : --> program.
:- op(3, xfy, [ & ] ).	% The user MUST declare the new operators
operator & : program * program --> program.
operator '.' : clause * program --> program.
operator any-identifier^M : --> program,
	{ object_module_source(M,S) }
	stands for S.

%%%%%%%
%%%%%%% Copyright (C) Henning Christiansen 1998, Roskilde University, Denmark
%%%%%%% E-mail henning@ruc.dk
%%%%%%% 
%%%%%%% The code contained in this file must not be applied
%%%%%%% in any commercial product without written permission
%%%%%%% from the copyright holder.
%%%%%%%
%%%%%%% Permission is granted to use, copy, modify, and distribute
%%%%%%% this file for scientific and educational purposes provided
%%%%%%% that the copyright notice and these remarks are maintained.
%%%%%%% The copyright holder or author takes no responsibility for
%%%%%%% any loss or damage caused by this code.
%%%%%%%
%%%%%%% Web site for the DemoII system: http://www.dat.ruc.dk/software/demo.html
