%%%%%%% This file is part of the DemoII system produced
%%%%%%% 1997-1999 by Davide Martinenghi and Henning Christiansen
%%%%%%%
%%%%%%% Contact:    henning@ruc.dk
%%%%%%%
%%%%%%% See legal notice in the end of this file.
%%%%%%%
%%%%%%% The code has been developed and tested for SICStus Prolog 3.7
%%%%%%%
%%%%%%% Filename: demo_oi.pl

:- dynamic no_info/0.
:- assert(no_info).
:- multifile portray_message/2.

%%% avoids messages about module consultation
user:portray_message(informational,_) :- no_info.

demo_compiled:-!,fail.

:- use_module('Source/loader').
:- use_module(library(system)).

:- demo_use_module('Source/es').
:- demo_use_module('Source/uti', [merge/2]).

:- merge(['Source/tc.pl', 'Source/ic_o.pl', 'Source/oc.pl', 'Source/sc.pl', 'Source/ac.pl', 'Source/df.pl'], demo_temporary),
	demo_consult(demo_temporary), delete_file(demo_temporary).
:- demo_consult('Source/closeconstraints').

:- demo_consult('Source/demo_predicate').

:- write('{DemoII is ready}'),nl.

:- retract(no_info).

%%%%%%%
%%%%%%% Copyright (C) Henning Christiansen 1998, Roskilde University, Denmark
%%%%%%% E-mail henning@ruc.dk
%%%%%%% 
%%%%%%% The code contained in this file must not be applied
%%%%%%% in any commercial product without written permission
%%%%%%% from the copyright holder.
%%%%%%%
%%%%%%% Permission is granted to use, copy, modify, and distribute
%%%%%%% this file for scientific and educational purposes provided
%%%%%%% that the copyright notice and these remarks are maintained.
%%%%%%% The copyright holder or author takes no responsibility for
%%%%%%% any loss or damage caused by this code.
%%%%%%%
%%%%%%% Web site for the DemoII system: http://www.dat.ruc.dk/software/index.html
